package roneditor;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.FontData;

/**
 * Some constants and identifiers used across all components of the RONEditor.
 * 
 * @author Tony Modica
 */
public interface IRonEditorConstants {

	/**
	 * This is the ID of the View for object nets according to plugin.xml.
	 */
	public static String objectNetViewID = "roneditor.objectnetview.ObjectNetPageBookView";

	/**
	 * This is the ID of the View for object nets according to plugin.xml.
	 */
	public static String ruleViewID = "roneditor.ruleview.RulePageBookView";

	/**
	 * This is the ID of the View for ron according to plugin.xml.
	 */
	public static String RONViewID = "roneditor.ronview.RONPageBookView";

	/**
	 * A shared {@link FontData} object for a 14 pt bold Sans font.
	 */
	public static FontData[] objectNetFontData = new FontData[] { new FontData(
			"Sans", 14, SWT.BOLD) };

	/**
	 * An identifier for the shared 14 pt bold Sans font.
	 */
	public static String objectNetFontID = "Sans14Bold";
}
