package roneditor.dialogs;

import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

public abstract class AbstractPropertiesDialog extends
		org.eclipse.swt.widgets.Dialog {
	protected Shell dialogShell;

	protected String title;

	protected boolean cancelled;

	public AbstractPropertiesDialog(Shell parent, int style) {
		super(parent, style);
		init();
	}

	public boolean isCancelled() {
		return cancelled;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public void open() {
		cancelled = false;
		dialogShell.open();
		dialogShell.setText(title);
		Display display = dialogShell.getDisplay();
		while (!dialogShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	protected void cancelMouseDown(MouseEvent evt) {
		cancelled = true;
		dialogShell.close();
	}

	protected abstract void init();
}
