package roneditor.objectnetview;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.gef.tools.CreationTool;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Shell;

import roneditor.RONActivator;
import roneditor.objectnetview.commands.CreateONPlaceCommand;
import roneditor.objectnetview.commands.CreateONTransitionCommand;
import roneditor.objectnetview.dialogs.ONPlacePropertiesDialog;
import roneditor.objectnetview.dialogs.ONTransitionPropertiesDialog;
/**
 * CreationTool for ObjectNets
 */
public class ObjectNetCreationTool extends CreationTool {

	public ObjectNetCreationTool() {
		super();
	}

	public ObjectNetCreationTool(CreationFactory factory) {
		super(factory);
	}
	/**
	 * Bei {@link CreateONPlaceCommand} oder {@link CreateONTransitionCommand} ffnet sich ein 
	 * Dialogfenster fr Benutzereingaben
	 * @see org.eclipse.gef.tools.AbstractTool#executeCurrentCommand()
	 */
	protected void executeCurrentCommand() {
		Command command = getCurrentCommand();
		if ((command instanceof CreateONPlaceCommand) && command.canExecute()) {
			if (!openNodeRoleDialog(command))
				return;
		} else if ((command instanceof CreateONTransitionCommand)
				&& command.canExecute()) {
			if (!openNodeRoleDialog(command))
				return;
		}
		super.executeCurrentCommand();
	}
	/**
	 * 
	 * @param command ist {@link CreateONPlaceCommand} oder {@link CreateONTransitionCommand} 
	 * @return true true wenn Alle Eingaben richtig sind, false bei Cancel oder
	 * wenn eine Eingabe Falsch ist
	 */
	private boolean openNodeRoleDialog(Command command) {
		if (command instanceof CreateONPlaceCommand) {
			CreateONPlaceCommand createONPlaceCommand = (CreateONPlaceCommand) command;
			Shell shell = RONActivator.getDefault().getWorkbench()
					.getActiveWorkbenchWindow().getShell();
			ONPlacePropertiesDialog d = new ONPlacePropertiesDialog(shell,
					SWT.NULL);
			d.setTitle("Create ONPlace");
			d.setTokens(0);
			d.open();
			String placeName = d.getPlaceName() == "" ? null : d.getPlaceName();
			if (d.isCancelled() || d.getTokens() < 0) {
				return false;
			}
			createONPlaceCommand.setName(placeName);
			createONPlaceCommand.setTokens(d.getTokens());
		} else if (command instanceof CreateONTransitionCommand) {
			CreateONTransitionCommand createONTransitionCommand = (CreateONTransitionCommand) command;
			Shell shell = RONActivator.getDefault().getWorkbench()
					.getActiveWorkbenchWindow().getShell();
			ONTransitionPropertiesDialog d = new ONTransitionPropertiesDialog(
					shell, SWT.NULL);
			d.setTitle("Create ONTransition");
			d.open();
			String transitionName = d.getTransitionName() == "" ? null : d
					.getTransitionName();
			if (d.isCancelled()) {
				return false;
			}
			createONTransitionCommand.setName(transitionName);
		}
		return true;
	}

}