package roneditor.objectnetview.commands;

import roneditor.model.RONModelManager;
import ronmodel.RonmodelFactory;

/**
 * CreateBendpointCommand creates a new Bendpoint.
 */
public class CreateBendpointCommand extends AbstractBendpointCommand {
	/**
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		RonmodelFactory mfc = RONModelManager.getFactory();
		bendPoint = mfc.createBendPoint();
		// Speichern der relative Position zur 1. ClassifierRole
		bendPoint.getH().add(new Integer(getFirstRelativeDimension().height));
		bendPoint.getW().add(new Integer(getFirstRelativeDimension().width));

		// Speichern der relativen Position zur 2. ClassifierRole
		bendPoint.getH().add(new Integer(getSecondRelativeDimension().height));
		bendPoint.getW().add(new Integer(getSecondRelativeDimension().width));

		// BendPoint hinzufgen
		getONArc().getBendPoints().add(getIndex(), bendPoint);
	}
	/**
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		getONArc().getBendPoints().remove(bendPoint);
	}
}
