package roneditor.objectnetview.commands;

import org.eclipse.gef.commands.Command;

import ronmodel.ONArc;
/**
 * Edit onArc properties.
 */
public class EditONArcCommand extends Command {
	private ONArc onArc;

	private int oldWeight;

	private int newWeight;

	public EditONArcCommand() {
		setLabel("edit arc");
	}

	/**
	 * Properties von einem {@link ONArc} ndern
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		oldWeight = getOnArc().getWeight();
		getOnArc().setWeight(newWeight);
	}

	/**
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		getOnArc().setWeight(oldWeight);
	}

	/**
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	public void redo() {
		getOnArc().setWeight(newWeight);
	}

	public int getNewWeight() {
		return newWeight;
	}

	public void setNewWeight(int newWeight) {
		this.newWeight = newWeight;
	}

	public ONArc getOnArc() {
		return onArc;
	}

	public void setOnArc(ONArc onArc) {
		this.onArc = onArc;
	}
}
