package roneditor.objectnetview.commands;

import ronmodel.ONPlace;
/**
 * Edit onPlace properties.
 */
public class EditONPlaceCommand extends EditONNodeCommand {
	private int oldTokens;

	private int newTokens;

	public EditONPlaceCommand() {
		setLabel("edit place");
	}

	public ONPlace getONPlace() {
		return (ONPlace) getONNode();
	}

	/**
	 * Properties von einem {@link ONPlace} werden gendert
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		super.execute();
		oldTokens = getONPlace().getTokens();
		getONPlace().setTokens(newTokens);
	}

	/**
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		super.undo();
		getONPlace().setTokens(oldTokens);
	}

	/**
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	public void redo() {
		super.redo();
		getONPlace().setTokens(newTokens);
	}

	public int getNewTokens() {
		return newTokens;
	}

	public void setNewTokens(int newTokens) {
		this.newTokens = newTokens;
	}
}
