package roneditor.objectnetview.commands;

import roneditor.model.RONModelManager;
import ronmodel.BendPoint;
import ronmodel.RonmodelFactory;

/**
 * MoveBendpoints enables a Bendpoint to be moved. It stores the new and the old
 * position of a Bendpoint
 */
public class MoveBendpointCommand extends AbstractBendpointCommand {

	public void execute() {
		RonmodelFactory mfc = RONModelManager.getFactory();
		// erzeugt einen neuen Bendpoint
		BendPoint bp = mfc.createBendPoint();
		// setzt die relative Dimension zum source Node
		bp.getH().add(new Integer(getFirstRelativeDimension().height));
		bp.getW().add(new Integer(getFirstRelativeDimension().width));
		// setzt die relative Dimension zum target Node
		bp.getH().add(new Integer(getSecondRelativeDimension().height));
		bp.getW().add(new Integer(getSecondRelativeDimension().width));

		// speichern von oldBendpoint
		setOldBendpoint((BendPoint) getONArc().getBendPoints().get(getIndex()));

		// einfuegen des neuen Bendpoint mit neuen Position
		getONArc().getBendPoints().set(getIndex(), bp);

	}

	/**
	 * @return BendPoint mit alten Position
	 */
	protected BendPoint getOldBendpoint() {
		return bendPoint;
	}

	/**
	 * setzt den BendPoint auf alte Position
	 */
	public void setOldBendpoint(BendPoint bp) {
		bendPoint = bp;
	}

	public void undo() {
		getONArc().getBendPoints().set(getIndex(), getOldBendpoint());
	}

}
