package roneditor.objectnetview.dialogs;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import roneditor.dialogs.AbstractPropertiesDialog;
import ronmodel.ONPlace;

/**
 * dialog  zum ndern die Properties eines {@link ONPlace}
 */
public class ONPlacePropertiesDialog extends AbstractPropertiesDialog {
	private Composite composite1;

	private Button cancelButton;

	private Button okButton;

	private Text nameValue;

	private Label nameLabel;

	private Text tokensValue;

	private Label tokensLabel;

	private String placeName;

	private int tokens;

	public ONPlacePropertiesDialog(Shell parent, int style) {
		super(parent, style);
	}

	public void init() {
		try {
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM
					| SWT.APPLICATION_MODAL);

			dialogShell.setLayout(new GridLayout());
			dialogShell.layout();
			dialogShell.pack();
			// dialogShell.setSize(160, 144);
			dialogShell.setBounds(450, 250, 160, 144);
			{
				composite1 = new Composite(dialogShell, SWT.NONE);
				FormLayout composite1Layout = new FormLayout();
				GridData composite1LData = new GridData();
				composite1LData.widthHint = 147;
				composite1LData.heightHint = 112;
				composite1.setLayoutData(composite1LData);
				composite1.setLayout(composite1Layout);

				{
					nameLabel = new Label(composite1, SWT.NONE);
					FormData weightLabelLData = new FormData();
					weightLabelLData.width = 42;
					weightLabelLData.height = 21;
					weightLabelLData.left = new FormAttachment(98, 1000, 0);
					weightLabelLData.right = new FormAttachment(384, 1000, 0);
					weightLabelLData.top = new FormAttachment(193, 1000, 0);
					weightLabelLData.bottom = new FormAttachment(336, 1000, 0);
					nameLabel.setLayoutData(weightLabelLData);
					nameLabel.setText("Name");
				}
				{
					FormData weightValueLData = new FormData();
					weightValueLData.width = 77;
					weightValueLData.height = 21;
					weightValueLData.left = new FormAttachment(431, 1000, 0);
					weightValueLData.right = new FormAttachment(955, 1000, 0);
					weightValueLData.top = new FormAttachment(193, 1000, 0);
					weightValueLData.bottom = new FormAttachment(336, 1000, 0);
					nameValue = new Text(composite1, SWT.NONE);
					nameValue.setLayoutData(weightValueLData);
					nameValue.setFocus();
				}

				{
					tokensLabel = new Label(composite1, SWT.NONE);
					FormData label1LData = new FormData();
					label1LData.width = 42;
					label1LData.height = 21;
					label1LData.left = new FormAttachment(98, 1000, 0);
					label1LData.right = new FormAttachment(384, 1000, 0);
					label1LData.top = new FormAttachment(431, 1000, 0);
					label1LData.bottom = new FormAttachment(574, 1000, 0);
					tokensLabel.setLayoutData(label1LData);
					tokensLabel.setText("Tokens");
				}
				{
					tokensValue = new Text(composite1, SWT.NONE);
					FormData text1LData = new FormData();
					text1LData.width = 77;
					text1LData.height = 21;
					text1LData.left = new FormAttachment(431, 1000, 0);
					text1LData.right = new FormAttachment(955, 1000, 0);
					text1LData.top = new FormAttachment(431, 1000, 0);
					text1LData.bottom = new FormAttachment(574, 1000, 0);
					tokensValue.setLayoutData(text1LData);
				}

				{
					okButton = new Button(composite1, SWT.PUSH | SWT.CENTER);
					FormData okButtonLData = new FormData();
					okButtonLData.width = 49;
					okButtonLData.height = 21;
					okButtonLData.left = new FormAttachment(0, 1000, 14);
					okButtonLData.top = new FormAttachment(0, 1000, 84);
					okButton.setLayoutData(okButtonLData);
					okButton.setText("Ok");
					okButton.addMouseListener(new MouseAdapter() {
						public void mouseDown(MouseEvent evt) {
							okMouseDown(evt);
						}
					});
				}

				{
					cancelButton = new Button(composite1, SWT.PUSH | SWT.CENTER);
					FormData cancelButtonLData = new FormData();
					cancelButtonLData.width = 49;
					cancelButtonLData.height = 21;
					cancelButtonLData.left = new FormAttachment(0, 1000, 91);
					cancelButtonLData.top = new FormAttachment(0, 1000, 84);
					cancelButton.setLayoutData(cancelButtonLData);
					cancelButton.setText("Cancel");
					cancelButton.addMouseListener(new MouseAdapter() {
						public void mouseDown(MouseEvent evt) {
							cancelMouseDown(evt);
						}
					});
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private void okMouseDown(MouseEvent evt) {
		placeName = nameValue.getText();
		try {
			tokens = Integer.parseInt(tokensValue.getText());
		} catch (Exception e) {
			tokens = -1;
		}
		dialogShell.close();
	}

	public void setPlaceName(String placeName) {
		if (placeName == null) {
			placeName = "";
		}
		nameValue.setText(placeName);
	}

	public String getPlaceName() {
		return placeName;
	}

	public int getTokens() {
		return tokens;
	}

	public void setTokens(int tokens) {
		tokensValue.setText("" + tokens);
	}

}
