package roneditor.objectnetview.dialogs;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import roneditor.dialogs.AbstractPropertiesDialog;
import ronmodel.ONTransition;

/**
 * dialog zum ndern die Properties eines {@link ONTransition}
 */
public class ONTransitionPropertiesDialog extends AbstractPropertiesDialog {
	private Composite composite1;

	private Button cancelButton;

	private Button okButton;

	private Text nameValue;

	private Label nameLabel;

	private String transitionName;

	public ONTransitionPropertiesDialog(Shell parent, int style) {
		super(parent, style);
	}

	public static void main(String[] args) {
		try {
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			ONTransitionPropertiesDialog inst = new ONTransitionPropertiesDialog(
					shell, SWT.NULL);
			inst.setTitle("ku ku");
			inst.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void init() {
		try {
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM
					| SWT.APPLICATION_MODAL);

			dialogShell.setLayout(new GridLayout());
			dialogShell.layout();
			dialogShell.pack();
			// dialogShell.setSize(160, 119);
			dialogShell.setBounds(450, 265, 160, 119);
			{
				composite1 = new Composite(dialogShell, SWT.NONE);
				FormLayout composite1Layout = new FormLayout();
				GridData composite1LData = new GridData();
				composite1LData.widthHint = 147;
				composite1LData.heightHint = 84;
				composite1.setLayoutData(composite1LData);
				composite1.setLayout(composite1Layout);

				{
					nameLabel = new Label(composite1, SWT.NONE);
					FormData weightLabelLData = new FormData();
					weightLabelLData.width = 42;
					weightLabelLData.height = 21;
					weightLabelLData.left = new FormAttachment(98, 1000, 0);
					weightLabelLData.right = new FormAttachment(384, 1000, 0);
					weightLabelLData.top = new FormAttachment(172, 1000, 0);
					weightLabelLData.bottom = new FormAttachment(422, 1000, 0);
					nameLabel.setLayoutData(weightLabelLData);
					nameLabel.setText("Name");
				}
				{
					FormData weightValueLData = new FormData();
					weightValueLData.width = 77;
					weightValueLData.height = 21;
					weightValueLData.left = new FormAttachment(431, 1000, 0);
					weightValueLData.right = new FormAttachment(955, 1000, 0);
					weightValueLData.top = new FormAttachment(172, 1000, 0);
					weightValueLData.bottom = new FormAttachment(422, 1000, 0);
					nameValue = new Text(composite1, SWT.NONE);
					nameValue.setLayoutData(weightValueLData);
					nameValue.setFocus();
				}

				{
					okButton = new Button(composite1, SWT.PUSH | SWT.CENTER);
					FormData okButtonLData = new FormData();
					okButtonLData.width = 49;
					okButtonLData.height = 21;
					okButtonLData.left = new FormAttachment(0, 1000, 14);
					okButtonLData.top = new FormAttachment(0, 1000, 56);
					okButton.setLayoutData(okButtonLData);
					okButton.setText("Ok");
					okButton.addMouseListener(new MouseAdapter() {
						public void mouseDown(MouseEvent evt) {
							okMouseDown(evt);
						}
					});
				}

				{
					cancelButton = new Button(composite1, SWT.PUSH | SWT.CENTER);
					FormData cancelButtonLData = new FormData();
					cancelButtonLData.width = 49;
					cancelButtonLData.height = 21;
					cancelButtonLData.left = new FormAttachment(0, 1000, 91);
					cancelButtonLData.top = new FormAttachment(0, 1000, 56);
					cancelButton.setLayoutData(cancelButtonLData);
					cancelButton.setText("Cancel");
					cancelButton.addMouseListener(new MouseAdapter() {
						public void mouseDown(MouseEvent evt) {
							cancelMouseDown(evt);
						}
					});
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private void okMouseDown(MouseEvent evt) {
		transitionName = nameValue.getText();
		dialogShell.close();
	}

	public void setTransitionName(String transitionName) {
		if (transitionName == null) {
			transitionName = "";
		}
		nameValue.setText(transitionName);
	}

	public String getTransitionName() {
		return transitionName;
	}
}
