package roneditor.objectnetview.figures;

import org.eclipse.draw2d.BendpointConnectionRouter;
import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.Connection;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.MidpointLocator;
import org.eclipse.draw2d.MouseEvent;
import org.eclipse.draw2d.MouseListener;
import org.eclipse.draw2d.MouseMotionListener;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.RectangleFigure;

import roneditor.figures.Mouse;

/**
 * Represents the graphical layout of a onArc.
 */
public class ONArcFigure extends PolylineConnection {
	protected Label label;

	public ONArcFigure(Connection con) {
		label = new Label("");
		setSourceAnchor(con.getSourceAnchor());
		setTargetAnchor(con.getTargetAnchor());
		MidpointLocator locator = new MidpointLocator(this, 0);
		RectangleFigure labelFigure = new RectangleFigure();
		labelFigure.setLayoutManager(new BorderLayout());
		labelFigure.setOutline(false);
		labelFigure.add(label, BorderLayout.CENTER);
		add(labelFigure, locator);
		addMouseListener(new MouseListener.Stub() {
			@Override
			public void mousePressed(MouseEvent me) {
				Mouse.getClickPosition().x = me.x;
				Mouse.getCurrentPosition().y = me.y;
				super.mousePressed(me);
			}
		});
		addMouseMotionListener(new MouseMotionListener.Stub() {
			@Override
			public void mouseMoved(MouseEvent me) {
				Mouse.getCurrentPosition().x = me.x;
				Mouse.getCurrentPosition().y = me.y;
				super.mouseMoved(me);
			}

			public void mouseDragged(MouseEvent me) {
				Mouse.getCurrentPosition().x = me.x;
				Mouse.getCurrentPosition().y = me.y;
				super.mouseDragged(me);
			}
		});
		// adds a BendpointConnectionRouter
		// for drawing Bendpoints
		setConnectionRouter(new BendpointConnectionRouter());
	}

	public void setWeight(int weight) {
		if (weight == 1)
			label.setText("");
		else
			label.setText(weight + "");
	}
}