package roneditor.objectnetview.model;

import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource;
import org.eclipse.ui.views.properties.PropertyDescriptor;

import roneditor.model.NumberCellEditorValidator;
import ronmodel.ONArc;

/**
 * Property source for onArc.
 */
public class ONArcPropertySource implements IPropertySource {
	final public static int ID_WEIGHT = 1;

	final private static IPropertyDescriptor[] descriptors;

	static {
		final PropertyDescriptor weightProp = new PropertyDescriptor(Integer
				.valueOf(ID_WEIGHT), "weight");
		weightProp.setValidator(NumberCellEditorValidator.instance(true));
		descriptors = new IPropertyDescriptor[] { weightProp };
	}

	private ONArc onArc;

	public ONArcPropertySource(final ONArc onArc) {
		this.onArc = onArc;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.views.properties.IPropertySource#getPropertyValue(java.lang.Object)
	 */
	public Object getPropertyValue(final Object id) {
		switch (((Integer) id).intValue()) {
		case ID_WEIGHT:
			return Integer.valueOf(onArc.getWeight()).toString();
		default:
			return null;
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.views.properties.IPropertySource#setPropertyValue(java.lang.Object,
	 *      java.lang.Object)
	 */
	public void setPropertyValue(final Object id, final Object value) {
		switch (((Integer) id).intValue()) {
		case ID_WEIGHT:
			onArc.setWeight(Integer.valueOf((String) value));
			break;
		default:
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.views.properties.IPropertySource#getEditableValue()
	 */
	public Object getEditableValue() {
		return onArc;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.views.properties.IPropertySource#getPropertyDescriptors()
	 */
	public IPropertyDescriptor[] getPropertyDescriptors() {
		return descriptors;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.views.properties.IPropertySource#resetPropertyValue(java.lang.Object)
	 */
	public void resetPropertyValue(final Object propName) {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.views.properties.IPropertySource#isPropertySet(java.lang.Object)
	 */
	public boolean isPropertySet(final Object propName) {
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "ONArc(" + onArc.getSource().getName() + "," + onArc.getWeight()
				+ "," + onArc.getTarget().getName() + ")";
	}

}
