package roneditor.ronview;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.gef.tools.CreationTool;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Shell;

import roneditor.RONActivator;
import roneditor.dialogs.CreateHLPlaceOrTokenDialog;
import roneditor.dialogs.HLTransitionPropertiesDialog;
import roneditor.ronview.commands.CreateHLPlaceCommand;
import roneditor.ronview.commands.CreateHLTransitionCommand;
import ronmodel.HLPlaceType;

public class RONCreationTool extends CreationTool {

	public RONCreationTool() {
		super();
	}

	public RONCreationTool(CreationFactory factory) {
		super(factory);
	}

	protected void executeCurrentCommand() {
		Command command = getCurrentCommand();
		if ((command instanceof CreateHLPlaceCommand) && command.canExecute()) {
			if (!openNodeRoleDialog(command))
				return;
		} else if ((command instanceof CreateHLTransitionCommand)
				&& command.canExecute()) {
			if (!openNodeRoleDialog(command))
				return;
		}
		super.executeCurrentCommand();
	}

	private boolean openNodeRoleDialog(Command command) {
		if (command instanceof CreateHLPlaceCommand) {
			CreateHLPlaceCommand createHLPlaceCommand = (CreateHLPlaceCommand) command;
			Shell shell = RONActivator.getDefault().getWorkbench()
					.getActiveWorkbenchWindow().getShell();
			final CreateHLPlaceOrTokenDialog dialog = new CreateHLPlaceOrTokenDialog(
					shell, SWT.NULL) {
				@Override
				protected void init() {
					// configure dialog
					getDialogShell().setText("Create place");
					getNetRadioButton().setEnabled(true);
					getNetRadioButton().setSelection(true);
					getRuleRadioButton().setEnabled(true);
					getRuleRadioButton().setSelection(false);
					getNameText().setText("newplace");
					getNameText().setFocus();
				}
			};
			dialog.open();
			if (dialog.isCancelled()) {
				return false;
			}
			createHLPlaceCommand.setName(dialog.getNameTextValue());
			if (dialog.isNetType()) {
				createHLPlaceCommand.setType(HLPlaceType.NET_LITERAL);
			} else {
				createHLPlaceCommand.setType(HLPlaceType.RULE_LITERAL);
			}
		} else if (command instanceof CreateHLTransitionCommand) {
			CreateHLTransitionCommand createHLTransitionCommand = (CreateHLTransitionCommand) command;
			Shell shell = RONActivator.getDefault().getWorkbench()
					.getActiveWorkbenchWindow().getShell();
			HLTransitionPropertiesDialog dialog = new HLTransitionPropertiesDialog(
					shell, SWT.NULL);
			dialog.setTitle("Create transition");
			dialog.open();
			if (dialog.isCancelled()) {
				return false;
			}
			createHLTransitionCommand.setName(dialog.getTransitionName());
			createHLTransitionCommand.setKind(dialog.getKind());
		}
		return true;
	}
}