package roneditor.ronview.commands;

import ronmodel.HLTransition;
import ronmodel.HLTransitionKind;
import ronmodel.RON;

/**
 * Command for adding a HLTransition to a RON. This is undoable.
 * 
 * @author Tony Modica
 */
public class CreateHLTransitionCommand extends org.eclipse.gef.commands.Command {

	private static final String CreateCommand_Label = "Create HLTransition";

	final private RON ron;

	private HLTransition transition;

	private String name;

	private HLTransitionKind kind;

	private int x;

	private int y;

	public CreateHLTransitionCommand(final RON ron,
			final HLTransition transition) {
		super(CreateHLTransitionCommand.CreateCommand_Label);
		this.ron = ron;
		this.transition = transition;
	}

	/**
	 * Executes the command by adding the HLTransition to the RON.
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	@Override
	public void execute() {
		transition.setRon(ron);
		transition.setName(name);
		transition.setKind(kind);
		transition.setX(x);
		transition.setY(y);
	}

	/**
	 * Undoes the command by removing the HLTransition from the RON.
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	@Override
	public void undo() {
		transition.setRon(null);
	}

	/**
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	@Override
	public void redo() {
		transition.setRon(ron);
	}

	/**
	 * @param name
	 *            the name to set
	 * 
	 */
	public void setName(final String name) {
		this.name = name;
	}

	public void setKind(HLTransitionKind kind) {
		this.kind = kind;
	}

	public void setX(int x) {
		this.x = x;
	}

	public void setY(int y) {
		this.y = y;
	}

}
