package roneditor.ronview.commands;

import ronmodel.HLPlace;
import ronmodel.Token;

/**
 * Command for adding a Token to a HLPlace. This is undoable.
 * 
 * @author Tony Modica
 */
public class CreateTokenCommand extends org.eclipse.gef.commands.Command {

	private static final String CreateCommand_Label = "Create Token";

	final private HLPlace place;

	private Token token;

	private String name;

	public CreateTokenCommand(final HLPlace place, final Token token) {
		super(CreateTokenCommand.CreateCommand_Label);
		this.place = place;
		this.token = token;
	}

	/**
	 * Executes the command by adding the Net to the HLPlace.
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	@Override
	public void execute() {
		token.setPlace(place);
		token.setName(name);
	}

	/**
	 * Undoes the command by removing the Token from the HLPlace.
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	@Override
	public void undo() {
		token.setPlace(null);
	}

	/**
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	@Override
	public void redo() {
		token.setPlace(place);
	}

	/**
	 * @see org.eclipse.gef.commands.Command#canExecute()
	 */
	@Override
	public boolean canExecute() {
		return name != null;
	}

	/**
	 * @param name
	 *            the name to set
	 */
	public void setName(final String name) {
		this.name = name;
	}
}
