package roneditor.ronview.commands;

import org.eclipse.draw2d.Bendpoint;

import roneditor.model.RONModelManager;
import roneditor.objectnetview.commands.AbstractBendpointCommand;
import ronmodel.BendPoint;
import ronmodel.RonmodelFactory;
/**
 * 
 * Command zum Verschieben eines {@link BendPoint}
 */
public class MoveHLBendpointCommand extends AbstractBendpointCommand {
	/**
	 * die Position eines existierendes {@link Bendpoint} wird
	 * gendert
	 */
	public void execute() {
		RonmodelFactory mfc = RONModelManager.getFactory();
		// neuen BendPoint erzeugen
		BendPoint bp = mfc.createBendPoint();
		// setzt die relative Dimension zum source Object
		bp.getH().add(new Integer(getFirstRelativeDimension().height));
		bp.getW().add(new Integer(getFirstRelativeDimension().width));
		// setzt die relative Dimension zum target Object
		bp.getH().add(new Integer(getSecondRelativeDimension().height));
		bp.getW().add(new Integer(getSecondRelativeDimension().width));

		// speichern von oldBendpoint
		setOldBendpoint((BendPoint) getHLArc().getBendPoints().get(getIndex()));

		// einfuegen von neuen Bendpoint mit neuen Position in Model
		getHLArc().getBendPoints().set(getIndex(), bp);
	}

	protected BendPoint getOldBendpoint() {
		return bendPoint;
	}

	public void setOldBendpoint(BendPoint bp) {
		bendPoint = bp;
	}
	/**
	 * 
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		getHLArc().getBendPoints().set(getIndex(), getOldBendpoint());
	}

}
