package roneditor.ronview.edit.parts;

import org.eclipse.draw2d.ConnectionAnchor;
import org.eclipse.gef.ConnectionEditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;
import roneditor.ronview.figures.HLPlaceFigure;
import roneditor.ronview.figures.HLTransitionFigure;
import ronmodel.HLNode;

/**
 * 
 * editpart for a {@link HLNode}
 */
public abstract class AbstractHLNodeEditPart extends AbstractGraphicalEditPart {

	public ConnectionAnchor getConnectionAnchor() {
		if (getFigure() instanceof HLTransitionFigure) {
			return ((HLTransitionFigure) getFigure()).getConnectionAnchor();
		} else if (getFigure() instanceof HLPlaceFigure) {
			return ((HLPlaceFigure) getFigure()).getConnectionAnchor();
		}
		return null;
	}

	public HLPlaceFigure getHLPlaceFigure() {
		return (HLPlaceFigure) getFigure();
	}

	/**
	 * @see org.eclipse.gef.NodeEditPart#getSourceConnectionAnchor(org.eclipse.gef.ConnectionEditPart)
	 */
	public ConnectionAnchor getSourceConnectionAnchor(
			ConnectionEditPart connection) {
		return getConnectionAnchor();
	}

	/**
	 * @see org.eclipse.gef.NodeEditPart#getSourceConnectionAnchor(org.eclipse.gef.Request)
	 */
	public ConnectionAnchor getSourceConnectionAnchor(Request request) {
		return getConnectionAnchor();
	}

	/** 
	 * @see org.eclipse.gef.NodeEditPart#getTargetConnectionAnchor(org.eclipse.gef.ConnectionEditPart)
	 */
	public ConnectionAnchor getTargetConnectionAnchor(
			ConnectionEditPart connection) {
		return getConnectionAnchor();
	}

	/**
	 * @see org.eclipse.gef.NodeEditPart#getTargetConnectionAnchor(org.eclipse.gef.Request)
	 */
	public ConnectionAnchor getTargetConnectionAnchor(Request request) {
		return getConnectionAnchor();
	}
}
