package roneditor.ruleview.actions;

import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.ui.IWorkbenchPart;

import roneditor.ruleview.RulePage;
import roneditor.ruleview.commands.CopyLHS2CodomainCommand;
import ronmodel.LHS;
import ronmodel.NAC;
/**
 * action fr Kopieren eines {@link LHS} nach {@link NAC}
 */
public class CopyLHS2NACAction extends SelectionAction {

	static public String ID = "copy LHS2NAC action";

	private RulePage rulePage;
	
	public CopyLHS2NACAction(IWorkbenchPart part, RulePage rulePage) {
		super(part);
		this.rulePage = rulePage;
		setId(ID);
		setText("Copy L->NAC");
		setDescription("Copy L->NAC");
		setToolTipText("Copy L->NAC");

	}
	/**
	 * @see org.eclipse.jface.action.Action#run()
	 */
	@Override
	public void run() {
		CopyLHS2CodomainCommand copyCommand = new CopyLHS2CodomainCommand();
		copyCommand.setCodomain((NAC) rulePage.getViewersContents(0));
		copyCommand.setLhs(rulePage.getRule().getLhs());
		execute(copyCommand);
	}
	/**
	 * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#calculateEnabled()
	 */
	@Override
	protected boolean calculateEnabled() {
		return !rulePage.getRule().getLhs().getNodes().isEmpty()
				&& ((NAC) rulePage.getViewersContents(0)).getNodes().isEmpty();
	}
}
