package roneditor.ruleview.actions;

import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.ui.IWorkbenchPart;

import roneditor.ruleview.RulePage;
import roneditor.ruleview.commands.CopyLHS2CodomainCommand;
import ronmodel.LHS;

/**
 * action fr kopieren  eines {@link LHS} nach {@link RHS}
 */
public class CopyLHS2RHSAction extends SelectionAction {

	static public String ID = "copy LHS2RHS action";

	private RulePage rulePage;
	
	public CopyLHS2RHSAction(IWorkbenchPart part, RulePage rulePage) {
		super(part);
		this.rulePage = rulePage;
		setId(ID);
		setText("Copy L->R");
		setDescription("Copy L->R");
		setToolTipText("Copy L->R");

	}
	/**
	 * @see org.eclipse.jface.action.Action#run()
	 */
	@Override
	public void run() {
		CopyLHS2CodomainCommand copyCommand = new CopyLHS2CodomainCommand();
		copyCommand.setCodomain(rulePage.getRule().getRhs());
		copyCommand.setLhs(rulePage.getRule().getLhs());
		execute(copyCommand);
	}
	/**
	 * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#calculateEnabled()
	 */
	@Override
	protected boolean calculateEnabled() {
		return !rulePage.getRule().getLhs().getNodes().isEmpty()
				&& rulePage.getRule().getRhs().getNodes().isEmpty();
	}
}
