package roneditor.ruleview.actions;

import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.ui.IWorkbenchPart;

import roneditor.ruleview.RulePage;
import roneditor.ruleview.commands.CopyRHS2NACCommand;
import ronmodel.NAC;
import ronmodel.RHS;
/**
 * action fr Kopieren eines {@link RHS} nach {@link NAC}
 */
public class CopyRHS2NACAction extends SelectionAction {

	static public String ID = "copy RHS2NAC action";

	private RulePage rulePage;

	public CopyRHS2NACAction(IWorkbenchPart part, RulePage rulePage) {
		super(part);
		this.rulePage = rulePage;
		setId(ID);
		setText("Copy R->NAC");
		setDescription("Copy R->NAC");
		setToolTipText("Copy R->NAC");

	}
	/**
	 * @see org.eclipse.jface.action.Action#run()
	 */
	@Override
	public void run() {
		CopyRHS2NACCommand copyCommand = new CopyRHS2NACCommand();
		copyCommand.setRhs(rulePage.getRule().getRhs());
		copyCommand.setNac((NAC) rulePage.getViewersContents(0));
		execute(copyCommand);
	}
	/**
	 * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#calculateEnabled()
	 */
	@Override
	protected boolean calculateEnabled() {
		return !rulePage.getRule().getRhs().getNodes().isEmpty()
				&& ((NAC) rulePage.getViewersContents(0)).getNodes().isEmpty();
	}
}
