package roneditor.ruleview.actions;

import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.ui.IWorkbenchPart;

import roneditor.ruleview.commands.DeleteMappingCommand;
import roneditor.ruleview.edit.parts.ONPlaceEditPart;
import roneditor.ruleview.edit.parts.ONTransitionEditPart;
import ronmodel.Mapping;
import ronmodel.ONNode;
/**
 * action for delete a mapping
 */
public class DeleteMappingAction extends SelectionAction {

	static public String ID = "delete Mapping action";

	public DeleteMappingAction(IWorkbenchPart part) {
		super(part);
		setId(ID);
		setText("delete Mapping");
		setDescription("delete Mapping");
		setToolTipText("delete Mapping");

	}
	/**
	 * @see org.eclipse.jface.action.Action#run()
	 */
	@Override
	public void run() {
		Object selection = ((StructuredSelection) getSelection())
				.getFirstElement();
		ONNode node = null;
		if (selection instanceof ONPlaceEditPart) {
			node = ((ONPlaceEditPart) selection).getONPlace();
		} else if (selection instanceof ONTransitionEditPart) {
			node = ((ONTransitionEditPart) selection).getONTransition();
		}

		if (node != null && !node.getIncomingMappings().isEmpty()) {
			Mapping mapping = (Mapping) node.getIncomingMappings().get(0);
			DeleteMappingCommand command = new DeleteMappingCommand();
			command.setMapping(mapping);
			execute(command);
		}
	}
	/**
	 * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#calculateEnabled()
	 */
	@Override
	protected boolean calculateEnabled() {
		Object selection = ((StructuredSelection) getSelection())
				.getFirstElement();
		ONNode node = null;
		if (selection instanceof ONPlaceEditPart) {
			node = ((ONPlaceEditPart) selection).getONPlace();
		} else if (selection instanceof ONTransitionEditPart) {
			node = ((ONTransitionEditPart) selection).getONTransition();
		}
		return node != null && !node.getIncomingMappings().isEmpty();
	}
}
