package roneditor.ruleview.actions;

import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.ui.IWorkbenchPart;

import roneditor.ruleview.RulePage;
import roneditor.ruleview.commands.DeleteNACCommand;
import ronmodel.NAC;
/**
 * action for delete a NAC
 */
public class DeleteNACAction extends SelectionAction {

	static public String ID = "delete NAC action";

	private RulePage rulePage;

	public DeleteNACAction(IWorkbenchPart part, RulePage rulePage) {
		super(part);
		this.rulePage = rulePage;
		setId(ID);
		setText("delete NAC");
		setDescription("delete NAC");
		setToolTipText("delete NAC");

	}

	@Override
	public void run() {
		DeleteNACCommand deleteCommand = new DeleteNACCommand();
		deleteCommand.setNac((NAC) rulePage.getViewersContents(0));
		execute(deleteCommand);
	}

	@Override
	protected boolean calculateEnabled() {
		return rulePage.getRule().getNacs().size() > 1;
	}
}
