package roneditor.ruleview.commands;

import org.eclipse.gef.commands.Command;

import ronmodel.NAC;
import ronmodel.Rule;
/**
 * command for a Nac-creation
 */
public class CreateNACCommand extends Command {

	private static final String createCommand_Label = "Create NAC Command";

	protected Rule rule;

	protected NAC nac;

	/**
	 * Constructor.
	 */
	public CreateNACCommand() {
		super(createCommand_Label);
	}
	/**
	 * ein Nac wird im {@link Rule} eingefgt
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	@Override
	public void execute() {
		nac.setRule(rule);
		int index = rule.getNacs().indexOf(nac) + 1;
		nac.setName("nac" + index);
	}
	/**
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	@Override
	public void undo() {
		nac.setRule(null);
	}
	/**
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	@Override
	public void redo() {
		execute();
	}
	public void setNac(NAC nac) {
		this.nac = nac;
	}

	public void setRule(Rule rule) {
		this.rule = rule;
	}

	@Override
	public boolean canExecute() {
		return rule != null && nac != null;
	}

}
