package roneditor.ruleview.edit.parts;

import java.util.List;
import java.util.Vector;

import org.eclipse.gef.EditPolicy;

import roneditor.objectnetview.edit.policies.ONNodeComponentEditPolicy;
import roneditor.ruleview.edit.policies.ONNodeEditPolicy;
import ronmodel.ONTransition;

/**
 * EditPart for a {@link ONTransition}.
 */
public class ONTransitionEditPart extends
		roneditor.objectnetview.edit.parts.ONTransitionEditPart {
	/**
	 * Creates a new {@link ONTransitionEditPart} instance.
	 * 
	 * @param onTransition
	 */
	public ONTransitionEditPart(ONTransition onTransition) {
		super(onTransition);
	}
	/**
	 * @see roneditor.objectnetview.edit.parts.ONTransitionEditPart#getModelSourceConnections()
	 */
	@Override
	protected List getModelSourceConnections() {
		List sourceConnections = new Vector();
		sourceConnections.addAll(super.getModelSourceConnections());
		return sourceConnections;
	}
	/**
	 * @see roneditor.objectnetview.edit.parts.ONTransitionEditPart#getModelTargetConnections()
	 */
	@Override
	protected List getModelTargetConnections() {
		List targetConnections = new Vector();
		targetConnections.addAll(super.getModelTargetConnections());
		return targetConnections;
	}

	/**
	 * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
	 */
	protected void createEditPolicies() {
		// install the edit policy to handle connection creation
		installEditPolicy(EditPolicy.GRAPHICAL_NODE_ROLE,
				new ONNodeEditPolicy());
		// install the edit policy to handle deletion
		installEditPolicy(EditPolicy.COMPONENT_ROLE,
				new ONNodeComponentEditPolicy());
	}
}
